SystemOrganization addCategory: #DefragFAT!

TestCase subclass: #DFDefragAppOneFileTest
	instanceVariableNames: 'app file disk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFDefragAppOneFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:53'!
setUp

	|pc|
	pc := DFComputer new.
	disk := DFHardDisk new.
	disk doAllocateSize: 40.  
	disk doFormatFAT.
	file := disk fileSystem doAddFile.
	file doAddFragmentFromIndex: 20 withBytes: 'Hel'.
	file doAddFragmentFromIndex: 3 withBytes: 'lo W'.
	file doAddFragmentFromIndex: 10 withBytes: 'orld!!!!'.
	app := DFDefragApp new.
	app hardDisk: disk.
	app defraggingFile: file.! !

!DFDefragAppOneFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 16:56'!
testDefrag

	self assert: 3 equals: file fragCount.
	app doDefrag.
	self assert: 1 equals: file fragCount.
	self assert: 'Hello World!!!!' equals: file contents asString.! !

!DFDefragAppOneFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:40'!
testInsideDefragFor

	app defraggingFile: file.
	app selectNextFragmentToMoveLeastIndexEmptySector.
	app assert: app fragmentToMoveLeastIndexEmptySector = (app defraggingFile fragments at: 1).
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:20 close:22. Range close:3 close: 6. Range close: 10 close: 15})).
	app leastIndexHinderingFragment moveToLastEmptySpace.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:20 close:22. Range close:37 close: 40. Range close: 10 close: 15})).
	app moveTheFragmentToLastEmptySpace.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:34 close:36. Range close:37 close: 40. Range close: 10 close: 15})).
	app moveTheFragmentToLeastIndexEmptySector.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:1 close:3. Range close:37 close: 40. Range close: 10 close: 15})).
	app selectNextFragmentToMoveLeastIndexEmptySector.
	app assert: app fragmentToMoveLeastIndexEmptySector = (app defraggingFile fragments at: 2).
	app moveTheFragmentToLeastIndexEmptySector.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:1 close:3. Range close:4 close: 7. Range close: 10 close: 15})).
	app selectNextFragmentToMoveLeastIndexEmptySector.
	app assert: app fragmentToMoveLeastIndexEmptySector = (app defraggingFile fragments at: 3).
	app leastIndexHinderingFragment moveToLastEmptySpace.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:1 close:3. Range close:4 close: 7. Range close: 35 close: 40})).
	app moveTheFragmentToLeastIndexEmptySector.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: ((app defraggingFile fragments  collect: [:each| each sectorRange]) = (OrderedCollection withAll: {Range close:1 close:3. Range close:4 close: 7. Range close: 8 close: 13})).
	app doUnifyToOneFragment.
	self assert: (app defraggingFile contents asString = 'Hello World!!!!').
	self assert: (app defraggingFile fragments size = 1).! !

!DFDefragAppOneFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:50'!
testOp0SetUp

	self assert: 'Hello World!!!!' equals: file contents asString.
	self assert: 'lo W' asByteArray equals: (app  hardDisk bytesFrom:3 to: 6).
	self assert: 'orld!!!!' asByteArray equals: (app  hardDisk bytesFrom:10 to: 15).
	self assert: 'Hel' asByteArray equals: (app  hardDisk bytesFrom:20 to: 22).! !

TestCase subclass: #DFDefragAppTwoFileTest
	instanceVariableNames: 'app computer file1 file2 disk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 21:35'!
assertFragment: aDFFileFragment startingIndexIs: aSmallInteger stringIs: aByteString 

	self assert: aByteString equals: aDFFileFragment bytes asString.  
	self assert: aSmallInteger equals: aDFFileFragment startingIndex.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:35'!
printDebuggging

	^Dictionary new
		at: #file1 put: (file1 fragments collect: [:each| {each sectorRange. each bytes asString} ]);
		at: #file2 put: (file2 fragments collect: [:each| {each sectorRange. each bytes asString} ]);
		yourself! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:52'!
setUp

	super setUp.
	computer := DFComputer new.
	disk := DFHardDisk new.
	disk doAllocateSize: 80.  
	disk doFormatFAT.
	file1 := disk fileSystem doAddFile.
	file1 doAddFragmentFromIndex: 40 withBytes: 'Hel'.
	file1 doAddFragmentFromIndex: 1 withBytes: 'lo W'.
	file1 doAddFragmentFromIndex: 11 withBytes: 'orld!!!!'.
	file2 := disk fileSystem doAddFile.
	file2 doAddFragmentFromIndex: 24 withBytes:  'Smalltalk is pur'.
	file2 doAddFragmentFromIndex: 17 withBytes:  'e objec'. 
	file2 doAddFragmentFromIndex: 43 withBytes:  't-oriented la'.
	file2 doAddFragmentFromIndex: 5 withBytes:  'nguage'.
	app := DFDefragApp new.
	app hardDisk: disk.  
	! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:47'!
testDoDefrag

	| files |
	files := disk fileSystem files.
	file1 := files at: 1.
	file2 := files at: 2.
	app doDefrag.  	self flag: 'infinite loop bug.'.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smalltalk is pure object-oriented language'.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:21'!
testOp01

	| each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 5 stringIs: 'nguage'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 11 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 40 stringIs: 'Hel'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 77 stringIs: 'lo W'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:21'!
testOp02

	| each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hel'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 5 stringIs: 'nguage'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 11 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 77 stringIs: 'lo W'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:21'!
testOp03

	|each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.	
		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hel'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 11 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 71 stringIs: 'nguage'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 77 stringIs: 'lo W'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:20'!
testOp04

	| each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.	
	
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hel'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 4 stringIs: 'lo W'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 11 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:22'!
testOp05

	|each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.	
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hel'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 4 stringIs: 'lo W'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 65 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:23'!
testOp06

	|each|
	app defraggingFile: file1.
	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.	
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hel'.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 4 stringIs: 'lo W'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 8 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:25'!
testOp07

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:00'!
testOp08

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 28 stringIs: 'ltalk is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 64 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 71 stringIs: 'nguage'.
	self assert: (file2 fragments at: 1) equals: app fragmentToMoveLeastIndexEmptySector.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:31'!
testOp09

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.

	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 28 stringIs: 'ltalk is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 64 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:48'!
testOp10

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.

	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 28 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 32 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 64 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:53'!
testOp11

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 32 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 64 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:55'!
testOp12

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 22 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 64 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:57'!
testOp13

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 4.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 22 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 30 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 43 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:28'!
testOp14

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 4.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 5.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 22 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 30 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 58 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:29'!
testOp15

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 4.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 5.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 22 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 30 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 37 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 71 stringIs: 'nguage'.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:31'!
testOp16

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 4.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 5.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	
	each := app defraggingFile fragments at: 6.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smal'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 18 stringIs: 'ltal'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 22 stringIs: 'k is pur'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 30 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 5) startingIndexIs: 37 stringIs: 't-oriented la'.
	self assertFragment: (file2 fragments at: 6) startingIndexIs: 50 stringIs: 'nguage'.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:34'!
testOp17

	|each|
	app defraggingFile: file1.	
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.		
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.	
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	app doUnifyDefraggingFileToOneFragment.

	app defraggingFile: file2.
	each := app defraggingFile fragments at: 1.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 2.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 3.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 4.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveTheFragmentToLeastIndexEmptySector.
	each := app defraggingFile fragments at: 5.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	
	each := app defraggingFile fragments at: 6.
	app fragmentToMoveLeastIndexEmptySector: each.
	app moveHinderingFragmentsToLastEmtpySpace.
	app moveTheFragmentToLeastIndexEmptySector.
	
	app doUnifyDefraggingFileToOneFragment.
	
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 1 stringIs: 'Hello World!!!!'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 14 stringIs: 'Smalltalk is pure object-oriented language'.
! !

!DFDefragAppTwoFileTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:49'!
testSetUp

	| files |
	self assert: 80 equals:  disk diskSize.
	files := disk fileSystem files.
	file1 := files at: 1.
	file2 := files at: 2.
	self assertFragment: (file1 fragments at: 2) startingIndexIs: 1 stringIs: 'lo W'.
	self assertFragment: (file2 fragments at: 4) startingIndexIs: 5 stringIs: 'nguage'.
	self assertFragment: (file1 fragments at: 3) startingIndexIs: 11 stringIs: 'orld!!!!'.
	self assertFragment: (file2 fragments at: 2) startingIndexIs: 17 stringIs: 'e objec'.
	self assertFragment: (file2 fragments at: 1) startingIndexIs: 24 stringIs: 'Smalltalk is pur'.
	self assertFragment: (file1 fragments at: 1) startingIndexIs: 40 stringIs: 'Hel'.
	self assertFragment: (file2 fragments at: 3) startingIndexIs: 43 stringIs: 't-oriented la'.! !

TestCase subclass: #DFFATTest
	instanceVariableNames: 'fat hardDisk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFFATTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:39'!
setUp

	super setUp.
	hardDisk := DFHardDisk new.
	hardDisk doAllocateSize: 50.
	hardDisk doFormatFAT.
	fat := hardDisk fileSystem.  ! !

!DFFATTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 23:33'!
testDoAddFile

	fat doAddFile.
	self assert: 1 equals: fat files size! !

!DFFATTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 17:51'!
testEmpty

	|bytes|
	self flag: 'define #canPutFrom:to:   .   let #canPut:startingAt: use it.'.
	self flag: 'use Range class to compute canPut series'.
	bytes := ByteArray withAll: #(3 5 10).
	self deny: (fat canPut: bytes startingAt: 0).
	self assert: (fat canPut: bytes startingAt: 25).
	self assert: (fat canPut: bytes startingAt: 48).
	self deny: (fat canPut: bytes startingAt: 49).! !

!DFFATTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:52'!
testOneAlloc

	|file bytes|
	file := fat doAddFile.
	file doAddFragmentFromIndex: 15 withBytes: (ByteArray withAll: 'i am an headache for you'). 
	bytes := ByteArray withAll: #(3 5 10).
	self deny: (fat canPut: bytes startingAt: 0).
	self assert: (fat canPut: bytes startingAt: 12).
	self deny: (fat canPut: bytes startingAt: 13).
	self deny: (fat canPut: bytes startingAt: 30).
	self deny: (fat canPut: bytes startingAt: 38).
	self assert: (fat canPut: bytes startingAt: 39).
	self assert: (fat canPut: bytes startingAt: 48).
	self deny: (fat canPut: bytes startingAt: 49).
	! !

!DFFATTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 17:38'!
testgreatestPutableSectorIndexFor

	|file fragment obstacleFile |
	file := fat doAddFile.
	obstacleFile := fat doAddFile.
	file doAddFragmentFromIndex: 1 withBytes: (ByteArray withAll: 'fragment').
	fragment := file lastFragment.
	self assert: 43 equals: (fat greatestPutableSectorIndexFor: fragment).

	obstacleFile doAddFragmentFromIndex: 38 withBytes: (ByteArray withAll: 'obstacle').
	self assert: 30 equals: (fat greatestPutableSectorIndexFor: fragment).! !

TestCase subclass: #DFFileFragmentTest
	instanceVariableNames: 'hardDisk fat fragments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 13:40'!
setUp

	super setUp.
	hardDisk := DFHardDisk new.
	hardDisk doAllocateSize: 30.
	fat := DFFAT new.
	fat hardDisk: hardDisk.
	fragments := DFFileFragment new.
	fragments fileSystem: fat.! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testFATAccessBytes

	fragments startingIndex: 10.
	fragments doWriteBytes: (ByteArray withAll: 'hello world, baby').
	! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testFATAccessBytesErrorIfTooLong

	fragments startingIndex: 25.
	self should: [fragments doWriteBytes: (ByteArray withAll: 'hello world, baby')] raise: Error  
	.
	! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testFATAccessErrorIfStartingIndexTooBig

	self should: [ fragments startingIndex: 40] raise: Error.
	  
	! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testFATAccessErrorIfStartingIndexTooSmall

	self should: [ fragments startingIndex: -3] raise: Error.
	  
	! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:47'!
testFATAccessGoodStartingIndex

	self shouldnt: [ fragments startingIndex: 1 ] raise: Error.
	  
	! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testRead

	| data |
	data := ByteArray withAll: 'hello world, baby'.
	fragments startingIndex: 10.
	fragments doWriteBytes: data.
	self assert: data equals: fragments bytes! !

!DFFileFragmentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:46'!
testWrite

	| before after getBytes getFront getMiddle getBack |
	getBytes := [hardDisk diskBytes copy].
	before := getBytes value.
	fragments startingIndex: 10.
	fragments doWriteBytes: (ByteArray withAll: 'hello world, baby').
	after := getBytes value.
	
	getFront := [:bytes| bytes copyFrom:1 to:9 ].
	getMiddle := [:bytes| bytes copyFrom:10 to: 26 ].
	getBack := [:bytes| bytes copyFrom:27 to: bytes size ].
	self assert: (getFront value: before) = (getFront value: after).
	self deny:  (getMiddle value: before) = (getMiddle value: after).
	self assert: 'hello world, baby' equals: (getMiddle value: after) asString.
	self assert: (getBack value: before) = (getBack value: after).
! !

Object subclass: #DFComputer
	instanceVariableNames: 'disk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFComputer methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:45'!
doInstallHardDiskSize: anInteger

	self halt assert: disk isNil.
	disk := DFHardDisk new.
	disk doAllocateSize: anInteger.  ! !

!DFComputer methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:44'!
hardDisk

	self halt.
	^disk! !

Object subclass: #DFDefragApp
	instanceVariableNames: 'lastDefragByte defraggingFile fragmentToMoveLeastIndexEmptySector tooBigHideringFragments defraggedFragments hardDisk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 21:05'!
defraggingFile

	^ defraggingFile! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 19:19'!
defraggingFile: aDFFile 

	defraggingFile := aDFFile! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:23'!
dividFirstTooBigHinderingFragmentAndMoveItToLastEmtpySpace

	|tooBig|
	tooBig := tooBigHideringFragments first.
	defraggingFile divideFragment: tooBig byCuttingFirstBytesOfSize: self fileSystem  sizeOfEmptySpaceAtEndOfDisk.
	tooBigHideringFragments remove: tooBig.
	tooBig == fragmentToMoveLeastIndexEmptySector ifTrue: 
		[fragmentToMoveLeastIndexEmptySector := defraggingFile fragmentWithStartingIndex: fragmentToMoveLeastIndexEmptySector startingIndex]! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:47'!
doDefrag

	hardDisk fileSystem files do: [:each| self doDefragFor: each]! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:40'!
doDefragFor: aDFFile 

	defraggingFile := aDFFile.
	defraggedFragments := OrderedCollection new.

	[self undefraggedFragmentExists]
		whileTrue: [
			Transcript nextPutAll: '#entering loop';cr;flush.
			[fragmentToMoveLeastIndexEmptySector] beTranscriptedToSeeChangeBy: [self selectOneFragmentToMoveLeastIndexEmptySector].
			[self fileSystem printSummaryString] beTranscriptedToSeeChangeBy: [self moveHinderingFragmentsToLastEmtpySpace].  
			[self fileSystem printSummaryString] beTranscriptedToSeeChangeBy: [self moveTheFragmentToFirstEmptySpace].
			].
	self doUnifyDefraggingFileToOneFragment.! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 21:30'!
doUnifyDefraggingFileToOneFragment

	defraggingFile doUnifyToOneFragment! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:51'!
doUnifyToOneFragment

	hardDisk fileSystem files do: [:each| 
		defraggingFile := each.
		each doUnifyToOneFragment]! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:48'!
fileSystem

	^hardDisk fileSystem! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:26'!
fragmentToMoveLeastIndexEmptySector

	self flag: 'rename this to fragmentToBeMoveLeastIndexEmptySector'.
	^ fragmentToMoveLeastIndexEmptySector! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:26'!
fragmentToMoveLeastIndexEmptySector: aDFFileFragment 

	self flag: 'rename this to fragmentToBeMoveLeastIndexEmptySector'.
	fragmentToMoveLeastIndexEmptySector := aDFFileFragment! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 19:49'!
fragmentsOfFileSystem

	^self fileSystem fragments! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:55'!
hardDisk

	^ hardDisk! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:54'!
hardDisk: aDFHardDisk 

	hardDisk := aDFHardDisk! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 20:51'!
hinderingFragments

	| range |
	range := Range close: lastDefragByte + 1 close: lastDefragByte + fragmentToMoveLeastIndexEmptySector length.
	^self fragmentsOfFileSystem select: [:each| | interRange |
		interRange := each sectorRange intersection: range.
		interRange notNil and: [interRange span >= 0] ].! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 13:11'!
initialize 

	super initialize.
	lastDefragByte := 0.! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 13:11'!
lastDefragByte

	^lastDefragByte! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 21:27'!
leastIndexHinderingFragment
	^ self sortedHinderingFragments first! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:33'!
moveHinderingFragmentsToLastEmtpySpace

	self moveSmallEnoughHinderingFragmentsToLastEmtpySpace.
	[tooBigHideringFragments notEmpty ] whileTrue:
		[ [{fragmentToMoveLeastIndexEmptySector . defraggingFile fragments}] beTranscriptedToSeeChangeBy: [self dividFirstTooBigHinderingFragmentAndMoveItToLastEmtpySpace]
		].! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 23:37'!
moveSmallEnoughHinderingFragmentsToLastEmtpySpace

	tooBigHideringFragments := OrderedCollection new.
	self sortedHinderingFragments do: [:frag| 
		[frag moveToLastEmptySpace] on: Error do: [:exp|
			exp messageText = 'there is no such sector' 
				ifFalse: [ exp signal ].
			 tooBigHideringFragments add: frag
		] ].	! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 22:02'!
moveTheFragmentToFirstEmptySpace

	fragmentToMoveLeastIndexEmptySector moveToSectorIndex: (lastDefragByte + 1).
	lastDefragByte := fragmentToMoveLeastIndexEmptySector endingIndex.
	defraggedFragments add: fragmentToMoveLeastIndexEmptySector.! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 19:55'!
moveTheFragmentToLastEmptySpace

	self fileSystem moveToLastEmptySpaceForFragment: fragmentToMoveLeastIndexEmptySector! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 20:13'!
moveTheFragmentToLeastIndexEmptySector

	fragmentToMoveLeastIndexEmptySector moveToSectorIndex: (lastDefragByte+1).
	lastDefragByte := fragmentToMoveLeastIndexEmptySector endingIndex
	! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 21:13'!
selectNextFragmentToMoveLeastIndexEmptySector.

	fragmentToMoveLeastIndexEmptySector isNil 
		ifTrue: [fragmentToMoveLeastIndexEmptySector := defraggingFile fragments at: 1]
		ifFalse: [fragmentToMoveLeastIndexEmptySector := defraggingFile fragments at: ((defraggingFile fragments indexOf: fragmentToMoveLeastIndexEmptySector) + 1)].! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 21:26'!
selectOneFragmentToMoveLeastIndexEmptySector

	fragmentToMoveLeastIndexEmptySector := defraggingFile fragments detect: [:each| (defraggedFragments includes: each) not ].
	! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 21:27'!
sortedHinderingFragments
	^ self hinderingFragments asSortedCollection: [ :a :b | a startingIndex <= b startingIndex ]! !

!DFDefragApp methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 21:51'!
undefraggedFragmentExists

	^(defraggingFile fragments copyWithoutAll: defraggedFragments) notEmpty! !

Object subclass: #DFFAT
	instanceVariableNames: 'files hardDisk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:06'!
bytesFrom: integer1 to: integer2 

	^hardDisk bytesFrom: integer1 to: integer2 ! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 23:34'!
canPut: aByteArray startingAt: anInteger 

	(anInteger >= 1 and: [anInteger + aByteArray size - 1 <= hardDisk diskSize])
		ifFalse: [^false].  
	^files allSatisfy: [:f| (f allocationCollidesToPut: aByteArray startingAt: anInteger) not ]! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 23:17'!
doAddFile

	| newFile |
	newFile := DFFile new.
	newFile fileSystem: self.
	files add: newFile.
	^newFile! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:06'!
doWriteBytes: aByteString withStartingIndex: anInteger 

	hardDisk doWriteBytes: aByteString withStartingIndex: anInteger! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 12:23'!
doWriteBytesFrom: aSmallInteger to: aSmallInteger2 toStartingIndex: aSmallInteger3 

	| offset |
	offset := 0.
	aSmallInteger to: aSmallInteger2 do: [:sectorIndex| 
		hardDisk writeByteAt: sectorIndex to: aSmallInteger3+ offset.
		offset := offset + 1
		]
	! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:55'!
fileOfFragment: aDFFileFragment 

	^files detect: [:each | each hasFragment: aDFFileFragment]! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:02'!
files

	^ files! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 19:50'!
fragments

	^(files collect: [:each| each fragments]) concatenateAll! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/25/2011 19:29'!
greatestPutableSectorIndexFor: aDFFileFragment 

	| sectorIndex bytes |
	sectorIndex := self hardDiskSize - aDFFileFragment bytes size + 1.
	bytes := aDFFileFragment bytes.
	[ self canPut: bytes startingAt: sectorIndex ] whileFalse: 
		[ sectorIndex := sectorIndex - 1.
		sectorIndex < 1 ifTrue: [ self error: 'there is no such sector' ] ].
	^sectorIndex! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 15:59'!
hardDisk: aDFHardDisk 

	hardDisk := aDFHardDisk ! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 16:19'!
hardDiskSize

	^hardDisk diskSize! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:07'!
initialize 

	super initialize.
	files := OrderedCollection new.! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:41'!
isSectorEmptyAtIndex: aSmallInteger 

	^self fragments allSatisfy: [:frag| 
		(frag sectorRange includes: aSmallInteger) not 
		]  ! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:40'!
lastEmptySectorIndex

	|index|
	index := hardDisk diskSize.
	[self isSectorEmptyAtIndex: index]
		whileFalse: [ index := index - 1. 
				index<1 ifTrue: [self error: 'disk is full!!'] ].
	^index! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 21:45'!
moveToLastEmptySpaceForFragment: aDFFileFragment 

	| anInteger |
	anInteger := self greatestPutableSectorIndexFor: aDFFileFragment.
	self doWriteBytesFrom: aDFFileFragment startingIndex to: aDFFileFragment endingIndex toStartingIndex: anInteger.
	aDFFileFragment startingIndex: anInteger.
	self flag: 'aDFFileFragment moveToLastEmptySpace. will do the same.'.! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:47'!
printSummaryString

	|string|
	string := hardDisk diskBytes collect: [:ch| $* charCode ].
	files do: [:f| f fragments do: [:fr| | range |
			range := fr sectorRange.
			string replaceFrom: range start to:  range stop with: fr bytes startingAt: 1
			]
		 ].
	^string asString! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:50'!
sectorIndexOfEmptySpaceStartByReverselySearchingFrom: aSmallInteger 

	| index |
	index := aSmallInteger.
	[ index := index - 1.
	index < 1 ifTrue: [^1].
	self isSectorEmptyAtIndex: index ] whileTrue.
	^index+1! !

!DFFAT methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:42'!
sizeOfEmptySpaceAtEndOfDisk

	|index|
	index := self lastEmptySectorIndex.
	^(index - (self sectorIndexOfEmptySpaceStartByReverselySearchingFrom: index)) + 1.
	! !

Object subclass: #DFFile
	instanceVariableNames: 'fragments fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:50'!
allocationCollidesToPut: aByteArray startingAt: anInteger 

	^fragments anySatisfy: [:each| each allocationCollidesToPut: aByteArray startingAt: anInteger ]! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 12:08'!
contents

	^(fragments collect: #bytes) concatenateAll! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 21:58'!
divideFragment: aDFFileFragment byCuttingFirstBytesOfSize: aSmallInteger 

	|oldFragments| 
	oldFragments := fragments copy.
	fragments := OrderedCollection new.
	oldFragments do: [:frag| 
		frag == aDFFileFragment 
			ifTrue: [
				|fragBytes|
				fragBytes := frag bytes.
				self doAddFragmentFromIndex: frag startingIndex withBytes: (fragBytes copyFrom: 1 to: aSmallInteger).
				self doAddFragmentFromIndex: frag startingIndex + aSmallInteger withBytes: (fragBytes copyFrom: aSmallInteger + 1 to:  fragBytes size).
				]
			ifFalse: [fragments addLast: frag]  
		].! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 13:40'!
doAddFragmentFromIndex: anInteger withBytes: aByteArray 

	| bytes |
	bytes := DFFileFragment new.
	bytes fileSystem: fileSystem.
	bytes startingIndex: anInteger.
	bytes doWriteBytes: aByteArray.
	
	fragments add: bytes.! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:50'!
doDeleteFile

	fragments := OrderedCollection new.! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 23:55'!
doUnifyToOneFragment

	| unifiedFragment firstIndex concatenatedBytes |
	(fragments allSatisfyCouple: [:aFrag :nextFrag| 
		aFrag isAdjacentTo: nextFrag]) ifFalse: [self error: 'cannot unify discontinous fragments'].
	
	firstIndex := fragments first startingIndex.
	concatenatedBytes := (fragments collect: #bytes) concatenateAll.
	fragments := OrderedCollection new.
	self doAddFragmentFromIndex: firstIndex withBytes: concatenatedBytes.! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 17:17'!
fileSystem

	^ fileSystem! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:19'!
fileSystem: aDFFAT 

	fileSystem := aDFFAT! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:50'!
fragCount

	^fragments size! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 12:05'!
fragmentOfLeastStartingIndex
	^ (self fragments asSortedCollection: [ :a :b | a startingIndex <= b startingIndex ]) first! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2011 00:09'!
fragmentWithStartingIndex: aSmallInteger 

	^self fragments detect: [:each| each startingIndex = aSmallInteger ]! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:50'!
fragments

	^fragments! !

!DFFile methodsFor: 'accessing' stamp: 'hjo 4/27/2011 22:19'!
fragments: anObject
	fragments := anObject! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:53'!
hasFragment: aDFFileFragment 

	^fragments includes: aDFFileFragment   ! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/23/2011 18:50'!
initialize 

	super initialize.
	fragments := OrderedCollection new.! !

!DFFile methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 17:30'!
lastFragment

	^fragments last! !

Object subclass: #DFFileFragment
	instanceVariableNames: 'startingIndex length fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 23:47'!
allocationCollidesToPut: aByteArray startingAt: anInteger 

	^((anInteger + aByteArray size - 1) < startingIndex or: 
	[
		(startingIndex + length - 1)  < anInteger
	]) not.
! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2011 00:53'!
beDividedFragmentsByCuttingFirstBytesOfSize: aSmallInteger 

	(fileSystem fileOfFragment: self)
		divideFragment: self byCuttingFirstBytesOfSize: aSmallInteger! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 20:48'!
beScatteredAndFillEndOfDisk

	self beDividedFragmentsByCuttingFirstBytesOfSize: fileSystem sizeOfEmptySpaceAtEndOfDisk! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 19:45'!
bytes

	^fileSystem bytesFrom: startingIndex to: startingIndex + length - 1! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 19:27'!
doWriteBytes: aByteArray 

	fileSystem doWriteBytes: aByteArray withStartingIndex: startingIndex.	
	length := aByteArray size.! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 08:59'!
endingIndex

	^startingIndex + length - 1! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/27/2011 22:02'!
fileSystem

	^ fileSystem! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:34'!
fileSystem: aFileSystem 

	fileSystem := aFileSystem! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 09:05'!
isAdjacentTo: aDFDiskFragment 

	^self endingIndex + 1 = aDFDiskFragment startingIndex ! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 13:15'!
length

	^ length! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 21:41'!
moveToLastEmptySpace
	self moveToSectorIndex: (self fileSystem greatestPutableSectorIndexFor: self)! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 12:27'!
moveToSectorIndex: anInteger 

	fileSystem doWriteBytesFrom: startingIndex to: self endingIndex toStartingIndex: anInteger.
	self startingIndex: anInteger  ! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 21:31'!
printOn: stream

	stream nextPutAll: 'frag'.
	stream nextPut: $(.
	stream nextPut: $".
	stream nextPutAll: self bytes asString.
	stream nextPut: $".
	stream space.
	stream print: startingIndex.
	stream nextPut: $).! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 19:51'!
sectorRange

	^Range close: startingIndex close:  startingIndex + length - 1! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/18/2011 00:10'!
startingIndex

	^ startingIndex! !

!DFFileFragment methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:35'!
startingIndex: anInteger 

	anInteger > fileSystem hardDiskSize ifTrue: [self error: 'starting index greater than harddisk limit'].  	
	anInteger < 1 ifTrue: [self error: 'starting index less than 1'].  	
	startingIndex := anInteger ! !

Object subclass: #DFHardDisk
	instanceVariableNames: 'diskBytes fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DefragFAT'!

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:04'!
bytesFrom: integer1 to: integer2 

	^diskBytes copyFrom: integer1 to: integer2! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 19:37'!
diskBytes

	^ diskBytes! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 16:20'!
diskSize

	^diskBytes size! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:04'!
doAllocateSize: anInteger 

	self assert: diskBytes isNil.
	diskBytes := ByteArray new: anInteger.! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:14'!
doFormatFAT

	fileSystem := DFFAT new.
	fileSystem hardDisk: self.
! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 21:05'!
doWriteBytes: aString withStartingIndex: anInteger 

	diskBytes replaceFrom: anInteger to: anInteger + aString size - 1 with: aString! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:12'!
fileSystem

	^ fileSystem! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/17/2011 17:07'!
initialize 

	super initialize.! !

!DFHardDisk methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2011 12:24'!
writeByteAt: aSmallInteger to: aSmallInteger2 

	diskBytes at: aSmallInteger2 put: (diskBytes at: aSmallInteger)! !
